<script lang="ts">
  import { LayerCake, Svg, Html } from 'layercake';
  import { feature } from 'topojson-client';
  import { geoIdentity } from 'd3-geo';
  import { scaleQuantize } from 'd3-scale';
  import { format } from 'd3-format';

  import MapSvg from '$lib/components/pages/regional-contacts/Map.svg.svelte';
  import Tooltip from '$lib/components/pages/regional-contacts/Tooltip.svelte';

  // This example loads json data as json using @rollup/plugin-json
  import usStates from '$lib/assets/data/states-albers-10m.json';
  import stateData from '$lib/assets/data/us-states-data.json';

  const colorKey = 'color';

  /* --------------------------------------------
   * Create lookups to more easily join our data
   * `dataJoinKey` is the name of the field in the data
   * `mapJoinKey` is the name of the field in the map file
   */
  const dataJoinKey = 'name';
  const mapJoinKey = 'name';
  const dataLookup = new Map();

  // @ts-ignore
  const geojson = feature(usStates, usStates.objects.states);
  const projection = geoIdentity;

  stateData.forEach((d) => {
    dataLookup.set(d[dataJoinKey], d);
  });

  let evt: CustomEvent<any>;
  let hideTooltip = true;

  // Create a flat array of objects that LayerCake can use to measure
  // extents for the color scale
  // @ts-ignore
  const flatData = geojson.features.map((d) => d.properties);
  const colors = ['#05ac51', '#ffc100', '#f40202', '#00b0f0', '#ed7f2a'];

  const addCommas = format(',');

  function zLookup(d: any) {
    return dataLookup.get(d[mapJoinKey])[colorKey];
  }
</script>

<div class="chart-container">
  <LayerCake
    data={geojson}
    z={zLookup}
    zScale={scaleQuantize()}
    zRange={colors}
    {flatData}>
    <Svg>
      <MapSvg
        {projection}
        on:mousemove={(event) => {
          evt = event;
          hideTooltip = false;
        }}
        on:mouseout={() => (hideTooltip = true)} />
    </Svg>

    <Html pointerEvents={false}>
    {#if hideTooltip !== true}
      <Tooltip {evt} let:detail>
        <!-- For the tooltip, do another data join because the hover event only has the data from the geography data -->
        {@const tooltipData = { ...detail.props, region: dataLookup.get(detail.props[mapJoinKey])['region'] }}
        {#each Object.entries(tooltipData) as [key, value]}
          {@const keyCapitalized = key.replace(/^\w/, (d) => d.toUpperCase())}
          <div class="row">
            <span>{keyCapitalized}:</span>
            {typeof value === 'number' ? addCommas(value) : value}
          </div>
        {/each}
      </Tooltip>
    {/if}
    </Html>
  </LayerCake>
</div>

<style>
    /*
      The wrapper div needs to have an explicit width and height in CSS.
      It can also be a flexbox child or CSS grid element.
      The point being it needs dimensions since the <LayerCake> element will
      expand to fill it.
    */
    .chart-container {
        width: 100%;
        height: 250px;
    }
</style>
